#!/usr/bin/env python3

"""
Cuchulufm is a series of wrappers for bottle, mako and others and construct a simple headless cms.

Copyright (C) 2023 Antonio de la Rosa Caballero

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

from cuchulu.libraries.db.corefields import CharField
from slugify import slugify
from cuchulu.libraries.db.coreforms import HiddenForm

class SlugifyField(CharField):
    """Field for process text and slugify it"""
    
    def __init__(self, name, size=255, field_related=None, required=False):
        
        super(SlugifyField, self).__init__(name, size, required)
        
        self.name_form=HiddenForm
        
        self.field_related=field_related
    
    def check(self, value):
        
        value=slugify(value)
        
        if value=='':
            
            if self.model!=None and self.field_related!=None:
                
                self.model.post[self.field_related]=self.model.post.get(self.field_related, '')
                
                value=slugify(self.model.post[self.field_related])
                
                if value=='':
            
                    self.error=True
                    self.error_txt='Value is empty'
                    
                    return ''
        return value
    

